## ippsample 0.0~git20220607.72f89b3

=== Makefile ===
#
# Makefile for PDFio.
#
# Copyright © 2021-2022 by Michael R Sweet.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

# POSIX makefile
.POSIX:

# Variables...
AR		=	ar
ARFLAGS		=	cr
CC		=	cc
CFLAGS		=
CODESIGN_IDENTITY =	Developer ID
COMMONFLAGS	=	-Os -g
#COMMONFLAGS	=	-O0 -g -fsanitize=address
CPPFLAGS	=	'-DPDFIO_VERSION="$(VERSION)"'
DESTDIR		=	$(DSTROOT)
DSO		=	cc
DSOFLAGS	=
DSONAME		=
LDFLAGS		=
LIBS		=	-lm -lz
RANLIB		=	ranlib
VERSION		=	1.1
prefix		=	/usr/local


# Base rules
.SUFFIXES:	.c .h .o
.c.o:
	$(CC) $(CFLAGS) $(CPPFLAGS) $(COMMONFLAGS) -c $<


# Files
PUBHEADERS	=	\
			pdfio.h \
			pdfio-content.h
PUBOBJS		=	\
			pdfio-aes.o \
			pdfio-array.o \
			pdfio-common.o \
			pdfio-content.o \
			pdfio-crypto.o \
			pdfio-dict.o \
			pdfio-file.o \
			pdfio-md5.o \
			pdfio-object.o \
			pdfio-page.o \
			pdfio-rc4.o \
			pdfio-sha256.o \
			pdfio-stream.o \
			pdfio-string.o \
			pdfio-token.o \
			pdfio-value.o
LIBOBJS		=	\
			$(PUBOBJS) \
			ttf.o
OBJS		=	\
			$(LIBOBJS) \
			pdfiototext.o \
			testpdfio.o
TARGETS		=	\
			$(DSONAME) \
			libpdfio.a \
			pdfiototext \
			testpdfio


# Make everything
all:		$(TARGETS)

all-shared:
	if test `uname` = Darwin; then \
		$(MAKE) DSONAME="libpdfio.1.dylib" -$(MAKEFLAGS) all; \
	else \
		$(MAKE) COMMONFLAGS="-g -Os -fPIC" DSONAME="libpdfio.so.1" -$(MAKEFLAGS) all; \
	fi

debug:
	$(MAKE) -$(MAKEFLAGS) COMMONFLAGS="-g -fsanitize=address -DDEBUG=1" clean all

macos:
	$(MAKE) -$(MAKEFLAGS) COMMONFLAGS="-Os -mmacosx-version-min=10.14 -arch x86_64 -arch arm64" clean all


# Clean everything
clean:
	rm -f $(TARGETS) $(OBJS)


# Install everything
install:	$(TARGETS)
	-mkdir -p $(DESTDIR)$(prefix)/include
	cp $(PUBHEADERS) $(DESTDIR)$(prefix)/include
	-mkdir -p $(DESTDIR)$(prefix)/lib
	cp libpdfio.a $(DESTDIR)$(prefix)/lib
	$(RANLIB) $(DESTDIR)$(prefix)/lib/libpdfio.a
	if test "x$(DSONAME)" = xlibpdfio.so.1; then \
		cp $(DSONAME) $(DESTDIR)$(prefix)/lib; \
		ln -sf libpdfio.so.1 $(DESTDIR)$(prefix)/lib/libpdfio.so; \
	elif test "x$(DSONAME)" = xlibpdfio.1.dylib; then \
		cp $(DSONAME) $(DESTDIR)$(prefix)/lib; \
		codesign -s "$(CODESIGN_IDENTITY)" -o runtime --timestamp $(DESTDIR)$(prefix)/lib/libpdfio.1.dylib; \
		ln -sf libpdfio.1.dylib $(DESTDIR)$(prefix)/lib/libpdfio.dylib; \
	fi
	-mkdir -p $(DESTDIR)$(prefix)/lib/pkgconfig
	echo 'prefix="$(prefix)"' >$(DESTDIR)$(prefix)/lib/pkgconfig/pdfio.pc
	echo 'Version: $(VERSION)' >>$(DESTDIR)$(prefix)/lib/pkgconfig/pdfio.pc
	cat pdfio.pc.in >>$(DESTDIR)$(prefix)/lib/pkgconfig/pdfio.pc
	-mkdir -p $(DESTDIR)$(prefix)/share/doc/pdfio
	cp doc/pdfio.html doc/pdfio-512.png LICENSE NOTICE $(DESTDIR)$(prefix)/share/doc/pdfio
	-mkdir -p $(DESTDIR)$(prefix)/share/man/man3
	cp doc/pdfio.3 $(DESTDIR)$(prefix)/share/man/man3

install-shared:
	if test `uname` = Darwin; then \
		$(MAKE) DSONAME="libpdfio.1.dylib" -$(MAKEFLAGS) install; \
	else
		$(MAKE) DSONAME="libpdfio.so.1" -$(MAKEFLAGS) install; \
	fi


# Test everything
test:	testpdfio
	./testpdfio

valgrind:	testpdfio
	valgrind --leak-check=full ./testpdfio


# pdfio library
libpdfio.a:		$(LIBOBJS)
	$(AR) $(ARFLAGS) $@ $(LIBOBJS)
	$(RANLIB) $@

libpdfio.so.1:		$(LIBOBJS)
	$(CC) $(DSOFLAGS) $(COMMONFLAGS) -shared -o $@ -Wl,-soname,$@ $(LIBOBJS) $(LIBS)

libpdfio.1.dylib:	$(LIBOBJS)
	$(CC) $(DSOFLAGS) $(COMMONFLAGS) -dynamiclib -o $@ -install_name $(prefix)/lib/$@ -current_version $(VERSION) -compatibility_version 1.0 $(LIBOBJS) $(LIBS)


# pdfio1.def (Windows DLL exports file...)
#
# I'd love to use __declspec(dllexport) but MS puts it before the function
# declaration instead of after like everyone else, and it breaks Codedoc and
# other tools I rely on...
pdfio1.def: $(LIBOBJS) Makefile
	echo Generating $@...
	echo "LIBRARY pdfio1" >$@
	echo "VERSION 1.0" >>$@
	echo "EXPORTS" >>$@
	nm $(LIBOBJS) 2>/dev/null | grep "T _" | awk '{print $$3}' | \
		grep -v '^_ttf' | sed -e '1,$$s/^_//' | sort >>$@


# pdfio text extraction (demo, doesn't handle a lot of things yet)
pdfiototext:		pdfiototext.o libpdfio.a
	$(CC) $(LDFLAGS) $(COMMONFLAGS) -o $@ pdfiototext.o libpdfio.a $(LIBS)


# pdfio test program
testpdfio:		testpdfio.o libpdfio.a
	$(CC) $(LDFLAGS) $(COMMONFLAGS) -o $@ testpdfio.o libpdfio.a $(LIBS)


# Dependencies
$(OBJS):		pdfio.h pdfio-private.h Makefile
pdfio-content.o:	pdfio-content.h ttf.h
ttf.o:			ttf.h

# Make documentation using Codedoc <https://www.msweet.org/codedoc>
DOCFLAGS	=	\
			--author "Michael R Sweet" \
			--copyright "Copyright (c) 2021-2022 by Michael R Sweet" \
			--docversion $(VERSION)

.PHONY: doc
doc:
	codedoc $(DOCFLAGS) --title "PDFio Programming Manual v$(VERSION)" $(PUBHEADERS) $(PUBOBJS:.o=.c) --body doc/pdfio.md --coverimage doc/pdfio-512.png pdfio.xml >doc/pdfio.html
	codedoc $(DOCFLAGS) --title "PDFio Programming Manual v$(VERSION)" --body doc/pdfio.md --coverimage doc/pdfio-epub.png pdfio.xml --epub doc/pdfio.epub
	codedoc $(DOCFLAGS) --title "pdf read/write library" --man pdfio --section 3 --body doc/pdfio.md pdfio.xml >doc/pdfio.3
	rm -f pdfio.xml


# Fuzz-test the library <>
.PHONY: afl
afl:
	$(MAKE) -$(MAKEFLAGS) CC="afl-clang-fast" COMMONFLAGS="-g" clean all
	test afl-output || rm -rf afl-output
	afl-fuzz -x afl-pdf.dict -i afl-input -o afl-output -V 600 -e pdf -t 5000 ./testpdfio @@


# Analyze code with the Clang static analyzer <https://clang-analyzer.llvm.org>
clang:
	clang $(CPPFLAGS) --analyze $(OBJS:.o=.c) 2>clang.log
	rm -rf $(OBJS:.o=.plist)
	test -s clang.log && (echo "$(GHA_ERROR)Clang detected issues."; echo ""; cat clang.log; exit 1) || exit 0


# Analyze code using Cppcheck <http://cppcheck.sourceforge.net>
cppcheck:
	cppcheck $(CPPFLAGS) --template=gcc --addon=cert.py --suppressions-list=.cppcheck $(OBJS:.o=.c) 2>cppcheck.log
	test -s cppcheck.log && (echo "$(GHA_ERROR)Cppcheck detected issues."; echo ""; cat cppcheck.log; exit 1) || exit 0

=== cups/Makefile ===
#
# Library Makefile for libcups.
#
# Copyright © 2021-2022 by OpenPrinting.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


#
# Object files...
#

LIBOBJS		= \
		array.o \
		auth.o \
		debug.o \
		dest.o \
		dest-job.o \
		dest-localization.o \
		dest-options.o \
		dir.o \
		encode.o \
		file.o \
		getputfile.o \
		globals.o \
		hash.o \
		http.o \
		http-addr.o \
		http-addrlist.o \
		http-support.o \
		ipp.o \
		ipp-file.o \
		ipp-support.o \
		langprintf.o \
		language.o \
		md5.o \
		notify.o \
		options.o \
		pwg-media.o \
		raster-error.o \
		raster-stream.o \
		request.o \
		string.o \
		tempfile.o \
		thread.o \
		tls.o \
		transcode.o \
		usersys.o \
		util.o
TESTOBJS	= \
		fuzzipp.o \
		rasterbench.o \
		testarray.o \
		testclient.o \
		testcreds.o \
		testdest.o \
		testfile.o \
		testgetdests.o \
		testhttp.o \
		testi18n.o \
		testipp.o \
		testoptions.o \
		testraster.o \
		testtestpage.o \
		testthreads.o \
		tlscheck.o
OBJS	=	\
		$(LIBOBJS) \
		$(TESTOBJS)

#		testcups.o \
#		testlang.o \
#		testpwg.o \


#
# Header files to install...
#

HEADERS	=	\
		array.h \
		base.h \
		cups.h \
		dir.h \
		file.h \
		http.h \
		ipp.h \
		language.h \
		pwg.h \
		raster.h \
		thread.h \
		transcode.h


#
# Targets in this directory...
#

LIBTARGETS =	\
		libcups.a \
		$(LIBCUPS)

UNITTARGETS =	\
		fuzzipp \
		rasterbench \
		testarray \
		testclient \
		testcreds \
		testdest \
		testfile \
		testgetdests \
		testhttp \
		testi18n \
		testipp \
		testoptions \
		testraster \
		testtestpage \
		testthreads \
		tlscheck

#		testcups \
#		testlang \
#		testpwg \

TARGETS	=	\
		$(LIBTARGETS)


#
# Make all targets...
#

all:		$(TARGETS)


#
# Make and run unit tests...
#

test:		$(UNITTARGETS)
	rm -f test.log
	echo Running array API tests...
	./testarray 2>>test.log
	echo Running file API tests...
	./testfile 2>>test.log
	echo Running HTTP API tests...
	./testhttp 2>>test.log
	echo Running IPP API tests...
	./testipp 2>>test.log
	echo Fuzzing IPP API...
	./fuzzipp 2>>test.log
	echo Running internationalization API tests...
	./testi18n 2>>test.log
	echo Running option API tests...
	./testoptions 2>>test.log
	echo Running raster API tests...
	./testraster 2>>test.log
	./testtestpage 2>>test.log


#
# Remove object and target files...
#

clean:
	$(RM) $(OBJS) $(TARGETS) $(UNITTARGETS)
	$(RM) libcups.so libcups.dylib


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM -I.. -D_CUPS_SOURCE $(CPPFLAGS) $(OPTIONS) $(OBJS:.o=.c) | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies


#
# Install all targets...
#

install:	all $(INSTALL_STATIC)
	echo "Installing header files to $(BUILDROOT)$(includedir)/cups..."
	$(INSTALL_DIR) $(BUILDROOT)$(includedir)/cups
	for file in $(HEADERS); do \
		$(INSTALL_DATA) $$file $(BUILDROOT)$(includedir)/cups; \
	done
	echo "Installing libraries to $(BUILDROOT)$(libdir)..."
	$(INSTALL_DIR) $(BUILDROOT)$(libdir)
	$(INSTALL_LIB) $(LIBCUPS) $(BUILDROOT)$(libdir)
	if test $(LIBCUPS) = "libcups.so.3"; then \
		$(RM) $(BUILDROOT)$(libdir)/`basename $(LIBCUPS) .3`; \
		$(LN) $(LIBCUPS) $(BUILDROOT)$(libdir)/`basename $(LIBCUPS) .3`; \
	fi
	if test $(LIBCUPS) = "libcups.3.dylib"; then \
		$(RM) $(BUILDROOT)$(libdir)/libcups.dylib; \
		$(LN) $(LIBCUPS) $(BUILDROOT)$(libdir)/libcups.dylib; \
	fi
	if test "x$(SYMROOT)" != "x"; then \
		echo "Copying debug symbols to $(SYMROOT)..."; \
		$(INSTALL_DIR) $(SYMROOT); \
		cp $(LIBCUPS) $(SYMROOT); \
		dsymutil $(SYMROOT)/$(LIBCUPS); \
	fi

install-static:
	echo "Installing static libraries to $(BUILDROOT)$(libdir)..."
	$(INSTALL_DIR) $(BUILDROOT)$(libdir)
	$(INSTALL_LIB) libcups.a $(BUILDROOT)$(libdir)
	$(RANLIB) $(BUILDROOT)$(libdir)/libcups.a


#
# Uninstall object and target files...
#

uninstall:
	$(RM) $(BUILDROOT)$(libdir)/libcups.3.dylib
	$(RM) $(BUILDROOT)$(libdir)/libcups.a
	$(RM) $(BUILDROOT)$(libdir)/libcups.dylib
	$(RM) $(BUILDROOT)$(libdir)/libcups.so
	$(RM) $(BUILDROOT)$(libdir)/libcups.so.3
	-$(RMDIR) $(BUILDROOT)$(libdir)
	for file in $(HEADERS); do \
		$(RM) $(BUILDROOT)$(includedir)/cups/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(includedir)/cups


#
# libcups.so.3
#

libcups.so.3:	$(LIBOBJS)
	echo Linking $@...
	$(CC) $(DSOFLAGS) $(OPTIM) -o $@ $(LIBOBJS) $(LIBS)
	$(RM) `basename $@ .3`
	$(LN) $@ `basename $@ .3`


#
# libcups.3.dylib
#

libcups.3.dylib:	$(LIBOBJS)
	echo Linking $@...
	$(CC) $(DSOFLAGS) $(OPTIM) -o $@ -install_name $(libdir)/$@ \
		-current_version 3.0.0 -compatibility_version 3.0.0 \
		$(LIBOBJS) $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@
	$(RM) libcups.dylib
	$(LN) $@ libcups.dylib


#
# libcups.a
#

libcups.a:	$(LIBOBJS)
	echo Archiving $@...
	$(RM) $@
	$(AR) $(ARFLAGS) $@ $(LIBOBJS)
	$(RANLIB) $@


#
# libcups3.def (Windows DLL exports file...)
#

libcups3.def: $(LIBOBJS) $(IMAGEOBJS) Makefile
	echo Generating $@...
	echo "LIBRARY libcups3" >$@
	echo "VERSION 3.0" >>$@
	echo "EXPORTS" >>$@
	(nm $(LIBOBJS) 2>/dev/null | grep "T _" | awk '{print $$3}'; \
	 echo __cups_strcpy; echo __cups_gettimeofday; echo __cups_hstrerror) | \
		grep -v -E -e '^cups_debug' -e 'Block$$' -e '^__cupsApple' | \
		sed -e '1,$$s/^_//' | sort >>$@


#
# fuzzipp (dependency on static CUPS library is intentional)
#

fuzzipp:	fuzzipp.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ fuzzipp.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# rasterbench (dependency on static CUPS library is intentional)
#

rasterbench:	rasterbench.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ rasterbench.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testarray (dependency on static CUPS library is intentional)
#

testarray:	testarray.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testarray.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testclient (dependency on static libraries is intentional)
#

testclient:	testclient.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testclient.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testcreds (dependency on static CUPS library is intentional)
#

testcreds:	testcreds.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testcreds.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testcups (dependency on static CUPS library is intentional)
#

testcups:	testcups.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testcups.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testdest (dependency on static CUPS library is intentional)
#

testdest:	testdest.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testdest.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testfile (dependency on static CUPS library is intentional)
#

testfile:	testfile.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testfile.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testgetdests (dependency on static CUPS library is intentional)
#

testgetdests:	testgetdests.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testgetdests.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testhttp (dependency on static CUPS library is intentional)
#

testhttp:	testhttp.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testhttp.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testipp (dependency on static CUPS library is intentional)
#

testipp:	testipp.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testipp.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testi18n (dependency on static CUPS library is intentional)
#

testi18n:	testi18n.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testi18n.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testlang (dependency on static CUPS library is intentional)
#

testlang:	testlang.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testlang.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@
	echo Creating locale directory structure...
	$(RM) -r locale
	for po in ../locale/cups_*.po; do \
		lang=`basename $$po .po | sed -e '1,$$s/^cups_//'`; \
		$(MKDIR) locale/$$lang; \
		$(LN) ../../$$po locale/$$lang; \
	done
	echo Running language API tests...
	echo ls -al locale
	ls -al locale
	LOCALEDIR=locale ./testlang


#
# testoptions (dependency on static CUPS library is intentional)
#

testoptions:	testoptions.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testoptions.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testpwg (dependency on static CUPS library is intentional)
#

testpwg:	testpwg.o libcups.a test.ppd
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testpwg.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@
	echo Running PWG API tests...
	./testpwg test.ppd


#
# testraster (dependency on static CUPS library is intentional)
#

testraster:	testraster.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testraster.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testtestpage (dependency on static CUPS library is intentional)
#

testtestpage:	testtestpage.o libcups.a
	echo Compiling $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testtestpage.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# testthreads (dependency on static CUPS library is intentional)
#

testthreads:	testthreads.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ testthreads.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# tlscheck (dependency on static CUPS library is intentional)
#

tlscheck:	tlscheck.o libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ tlscheck.o libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# Generate documentation using Codedoc (https://www.msweet.org/codedoc)
#

doc:
	echo "Generating CUPS Programming Manual..."
	$(RM) cupspm.xml
	codedoc --section "Programming" --body cupspm.md cupspm.xml \
		$(LIBOBJS:.o=.c) $(HEADERS) --coverimage cupspm.png \
		--epub ../doc/cupspm.epub
	codedoc --section "Programming" --body cupspm.md \
		cupspm.xml > ../doc/cupspm.html
	$(RM) cupspm.xml


#
# Lines of code computation...
#

sloc:
	echo "libcups: \c"
	sloccount $(LIBOBJS:.o=.c) 2>/dev/null | grep "Total Physical" | awk '{print $$9}'


#
# Dependencies...
#

include Dependencies
tls.o: tls-gnutls.c tls-openssl.c

=== doc/Makefile ===
#
# Documentation makefile for libcups.
#
# Copyright © 2021-2022 by OpenPrinting.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs

#
# Documentation files...
#

DOCFILES	=	\
			cupspm.epub \
			cupspm.html \
			ippevepcl.html \
			ippeveprinter.html \
			ipptool.html \
			ipptoolfile.html \
			raster-organization.png \
			raster.png \
			sample-image.png \
			spec-ipp.html \
			spec-raster.html


#
# Make all documents...
#

all:


#
# Make library targets...
#

libs:


#
# Make unit tests...
#

test:


#
# Remove all generated files...
#

clean:


#
# Dummy depend target...
#

depend:


#
# Install all documentation files...
#

install:
	echo "Installing documentation files to $(BUILDROOT)$(datadir)/doc/libcups..."
	$(INSTALL_DIR) $(BUILDROOT)$(datadir)/doc/libcups
	for file in $(DOCFILES); do \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(datadir)/doc/libcups; \
	done


#
# Uninstall all documentation files...
#

uninstall:
	echo "Uninstalling documentation files from $(BUILDROOT)$(datadir)/doc/libcups..."
	for file in $(DOCFILES); do \
		$(RM) $(BUILDROOT)$(datadir)/doc/libcups/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(datadir)/doc/libcups

=== examples/Makefile ===
#
# Example files makefile for libcups.
#
# Copyright © 2021-2022 by OpenPrinting.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

#
# Include standard definitions...
#

include ../Makedefs


#
# Examples...
#

DATAFILES	=	\
			color.jpg \
			document-a4.pdf \
			document-a4.ps \
			document-letter.pdf \
			document-letter.ps \
			gray.jpg \
			onepage-a4.pdf \
			onepage-a4.ps \
			onepage-letter.pdf \
			onepage-letter.ps \
			testfile.jpg \
			testfile.pcl \
			testfile.pdf \
			testfile.ps \
			testfile.txt
TESTFILES	=	\
			cancel-current-job.test \
			create-job-format.test \
			create-job-sheets.test \
			create-job-timeout.test \
			create-job.test \
			create-printer-subscription.test \
			cups-create-local-printer.test \
			fax-job.test \
			get-completed-jobs.test \
			get-devices.test \
			get-job-attributes.test \
			get-job-attributes2.test \
			get-job-template-attributes.test \
			get-jobs.test \
			get-notifications.test \
			get-ppd-printer.test \
			get-ppd.test \
			get-ppds-drv-only.test \
			get-ppds-language.test \
			get-ppds-make-and-model.test \
			get-ppds-make.test \
			get-ppds-product.test \
			get-ppds-psversion.test \
			get-ppds.test \
			get-printer-attributes-suite.test \
			get-printer-attributes.test \
			get-printer-description-attributes.test \
			get-printers-printer-id.test \
			get-printers.test \
			get-subscriptions.test \
			identify-printer-display.test \
			identify-printer-multiple.test \
			identify-printer.test \
			ipp-1.1.test \
			ipp-2.0.test \
			ipp-2.1.test \
			ipp-2.2.test \
			ipp-backend.test \
			ipp-everywhere.test \
			print-job.test \
			print-job-and-wait.test \
			print-job-deflate.test \
			print-job-gzip.test \
			print-job-hold.test \
			print-job-letter.test \
			print-job-manual.test \
			print-job-media-col.test \
			print-job-media-needed.test \
			print-job-password.test \
			print-job-raster.test \
			print-uri.test \
			set-attrs-hold.test \
			validate-job.test


#
# Make everything...
#

all:


#
# Make library targets...
#

libs:


#
# Make unit tests...
#

unittests:


#
# Clean everything...
#

clean:


#
# Dummy depend...
#

depend:


#
# Install all targets...
#

install:
	echo "Installing sample ipptool files in $(BUILDROOT)$(datadir)/cups/ipptool..."
	$(INSTALL_DIR) $(BUILDROOT)$(datadir)/cups/ipptool
	for file in $(DATAFILES) $(TESTFILES); do \
		$(INSTALL_DATA) $$file $(BUILDROOT)$(datadir)/cups/ipptool; \
	done


#
# Uninstall files...
#

uninstall:
	echo "Uninstalling sample ipptool files from $(BUILDROOT)$(datadir)/cups/ipptool..."
	for file in $(DATAFILES) $(TESTFILES); do \
		$(RM) $(BUILDROOT)$(datadir)/cups/ipptool/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(datadir)/cups/ipptool

=== locale/Makefile ===
#
# Locale file makefile for CUPS.
#
# Copyright © 2021-2022 by OpenPrinting.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS	=	checkpo.o po2strings.o strings2po.o
TARGETS	=	checkpo po2strings strings2po


#
# Make everything...
#

all:	$(TARGETS)


#
# Make library targets...
#

libs:


#
# Make unit tests...
#

unittests:


#
# Clean all config and object files...
#

clean:
	$(RM) $(TARGETS) $(OBJS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install all targets...
#

install:
	echo "Installing localization files to $(BUILDROOT)$(datadir)/locale..."
	$(INSTALL_DIR) $(BUILDROOT)$(datadir)/locale
	for loc in en $(LANGUAGES) ; do \
		if test -f cups_$$loc.po; then \
			$(INSTALL_DIR) $(BUILDROOT)$(datadir)/locale/$$loc ; \
			$(INSTALL_DATA) cups_$$loc.po $(BUILDROOT)$(datadir)/locale/$$loc/cups_$$loc.po ; \
		fi ; \
	done


#
# Uninstall files...
#

uninstall:
	echo "Uninstalling localization files from $(BUILDROOT)$(datadir)/locale..."
	for loc in en $(LANGUAGES) ; do \
		$(RM) $(BUILDROOT)$(datadir)/locale/$$loc/cups_$$loc.po ; \
	done


#
# pot - Creates/updates the cups.pot template file, merges changes into existing
#       message catalogs, and updates the cups.strings file.  We don't use
#       xgettext to update the cups.strings file due to known xgettext bugs.
#

pot:	checkpo po2strings
	echo Updating cups.pot...
	mv cups.pot cups.pot.bck
	touch cups.pot
	cd ..; xgettext -o locale/cups.pot -cTRANSLATORS -s \
		--keyword=_ --no-wrap --from-code utf-8 \
		--copyright-holder="OpenPrinting" \
		--package-name="CUPS" --package-version="$(CUPS_VERSION)" \
		--msgid-bugs-address="https://github.com/openprinting/cups/issues" \
		*/*.c */*.cxx
	(cat cups.header; tail +6 cups.pot) > cups.pot.N
	mv cups.pot.N cups.pot
	echo Checking cups.pot...
	./checkpo cups.pot
	for loc in *.po ; do \
		if test $$loc = '*.po'; then \
			break; \
		fi; \
		echo Merging changes into $$loc... ; \
		msgmerge -o $$loc -s -N --no-location $$loc cups.pot ; \
	done
	echo Updating cups.strings...
	./po2strings cups_en.po cups.strings

cups.strings: cups_en.po po2strings
	echo Updating cups.strings...
	./po2strings cups_en.po cups.strings


#
# checkpo - A simple utility to check PO files for correct translation
#           strings.  Dependency on static library is deliberate.
#
# checkpo filename.po [... filenameN.po]
#

checkpo:	checkpo.o ../cups/$(LIBCUPSSTATIC)
	echo Linking $@...
	$(LD_CC) $(ARCHFLAGS) $(ALL_LDFLAGS) -o checkpo checkpo.o \
		$(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@

checkall:	checkpo
	./checkpo *.po *.strings


#
# po2strings - A simple utility which uses iconv to convert GNU gettext
#              message catalogs to macOS .strings files.
#
# po2strings filename.po filename.strings
#

po2strings:	po2strings.o ../cups/$(LIBCUPSSTATIC)
	echo Linking $@...
	$(LD_CC) $(ARCHFLAGS) $(ALL_LDFLAGS) -o po2strings po2strings.o \
		$(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# strings2po - A simple utility which uses iconv to convert macOS .strings files
#              to GNU gettext message catalogs.
#
# strings2po filename.strings filename.po
#

strings2po:	strings2po.o
	echo Linking $@...
	$(LD_CC) $(ARCHFLAGS) $(ALL_LDFLAGS) -o strings2po strings2po.o
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# Dependencies...
#

include Dependencies

=== man/Makefile ===
#
# Man page makefile for libcups.
#
# Copyright © 2021 by OpenPrinting.
# Copyright © 2007-2019 by Apple Inc.
# Copyright © 1993-2006 by Easy Software Products.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


#
# Man pages...
#

MAN1	=	\
		ippeveprinter.1 \
		ippfind.1 \
		ipptool.1
MAN5	=	\
		ipptoolfile.5
MAN7	=	\
		ippevepcl.7


#
# Make everything...
#

all:		$(LOCALTARGET)


#
# Make unit tests...
#

test:


#
# Clean all config and object files...
#

clean:
	$(RM) mantohtml mantohtml.o


#
# Dummy depend target...
#

depend:


#
# Install all targets...
#

install:
	echo "Installing man pages in $(BUILDROOT)$(mandir)/man1..."
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man1
	for file in $(MAN1); do \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man1; \
	done
	echo "Installing man pages in $(BUILDROOT)$(mandir)/man5..."
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man5
	for file in $(MAN5); do \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man5; \
	done
	echo "Installing man pages in $(BUILDROOT)$(mandir)/man7..."
	$(INSTALL_DIR) -m 755 $(BUILDROOT)$(mandir)/man7
	for file in $(MAN7); do \
		$(INSTALL_MAN) $$file $(BUILDROOT)$(mandir)/man7; \
	done
	$(RM) $(BUILDROOT)$(mandir)/man7/ippeveps.7
	$(LN) ippevepcl.7 $(BUILDROOT)$(mandir)/man7/ippeveps.7


#
# Uninstall files...
#

uninstall:
	echo "Uninstalling man pages from $(BUILDROOT)$(mandir)/man1..."
	for file in $(MAN1); do \
		$(RM) $(BUILDROOT)$(mandir)/man1/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(mandir)/man1
	echo "Uninstalling man pages from $(BUILDROOT)$(mandir)/man5..."
	for file in $(MAN5); do \
		$(RM) $(BUILDROOT)$(mandir)/man5/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(mandir)/man5
	echo "Uninstalling man pages from $(BUILDROOT)$(mandir)/man7..."
	for file in $(MAN7) ippeveps.7; do \
		$(RM) $(BUILDROOT)$(mandir)/man7/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(mandir)/man7


#
# Local programs (not built when cross-compiling...)
#

local:	mantohtml


#
# Make html versions of man pages...
#

html:	mantohtml
	echo Converting man pages to HTML...
	for file in $(MAN1); do \
		echo "    $$file..."; \
		./mantohtml $$file >../doc/`basename $$file .1`.html; \
	done
	for file in $(MAN5); do \
		echo "    $$file..."; \
		./mantohtml $$file >../doc/`basename $$file .5`.html; \
	done
	for file in $(MAN7); do \
		echo "    $$file..."; \
		./mantohtml $$file >../doc/`basename $$file .7`.html; \
	done

mantohtml:	mantohtml.o ../cups/libcups.a
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ mantohtml.o ../cups/libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@

=== server/Makefile ===
#
# Makefile for sample IPP server.
#
# Copyright © 2014-2022 by the IEEE-ISTO Printer Working Group.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


#
# Object files...
#

OBJS 	=	\
		auth.o \
		client.o \
		conf.o \
		device.o \
		ipp.o \
		job.o \
		log.o \
		main.o \
		printer.o \
		resource.o \
		subscription.o \
		transform.o


#
# Targets in this directory...
#

TARGETS =	ippserver


#
# Make all targets...
#

all:		$(TARGETS)


#
# Remove object and target files...
#

clean:
	$(RM) $(OBJS) $(TARGETS)


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(CPPFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install the server.
#

install:	all
	echo "Installing server to $(BUILDROOT)$(sbindir)..."
	$(INSTALL_DIR) $(BUILDROOT)$(sbindir)
	$(INSTALL_BIN) ippserver $(BUILDROOT)$(sbindir)/ippserver


#
# Test the server.
#

test:


#
# ippserver
#

ippserver:	$(OBJS) ../libcups/cups/libcups.a ../pdfio/libpdfio.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)


#
# Embedded PNG headers...
#

pngheaders:
	echo "Generating printer-png.h from printer.png..."
	echo "static const unsigned char printer_png[] =" >printer-png.h
	echo "{" >>printer-png.h
	od -t x1 printer.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer-png.h
	echo "};" >>printer-png.h
	echo "Generating printer3d-png.h from printer3d.png..."
	echo "static const unsigned char printer3d_png[] =" >printer3d-png.h
	echo "{" >>printer3d-png.h
	od -t x1 printer3d.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer3d-png.h
	echo "};" >>printer3d-png.h


#
# Dependencies...
#

include Dependencies

=== tools/Makefile ===
#
# IPP tools makefile for libcups.
#
# Copyright © 2021-2022 by OpenPrinting.
# Copyright © 2007-2019 by Apple Inc.
# Copyright © 1997-2006 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS		=	\
			ippevepcl.o \
			ippeveprinter.o \
			ippeveps.o \
			ippfind.o \
			ipptool.o
IPPEVECOMMANDS	=	\
			ippevepcl \
			ippeveps
IPPTOOLS	=	\
			ippeveprinter \
			ippfind \
			ipptool
TARGETS		=	\
			$(IPPEVECOMMANDS) \
			$(IPPTOOLS) \
			$(LOCALTARGET)


#
# Make all targets...
#

all:		$(TARGETS)


#
# Make library targets...
#

libs:


#
# Make unit tests...
#

unittests:


#
# Clean all object files...
#

clean:
	$(RM) $(IPPTOOLS) $(IPPEVECOMMANDS) $(OBJS)
	$(RM) ippeveprinter-static ippfind-static ipptool-static


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM -I.. -D_CUPS_SOURCE $(CPPFLAGS) $(OPTIONS) $(OBJS:.o=.c) | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies


#
# Install all targets...
#

install:	all
	echo "Installing IPP tools to $(BUILDROOT)$(bindir)..."
	$(INSTALL_DIR) $(BUILDROOT)$(bindir)
	for file in $(IPPTOOLS); do \
		$(INSTALL_BIN) $$file $(BUILDROOT)$(bindir); \
	done
	echo "Installing printer commands to $(BUILDROOT)$(libexecdir)/command..."
	$(INSTALL_DIR) $(BUILDROOT)$(libexecdir)/command
	for file in $(IPPEVECOMMANDS); do \
		$(INSTALL_BIN) $$file $(BUILDROOT)$(bindir); \
		$(LN) $(bindir)/$$file $(BUILDROOT)$(libexecdir)/ippeveprinter; \
	done
	if test "x$(SYMROOT)" != "x"; then \
		echo "Copying debug symbols to $(SYMROOT)..."; \
		$(INSTALL_DIR) $(SYMROOT); \
		for file in $(IPPTOOLS) $(IPPEVECOMMANDS); do \
			cp $$file $(SYMROOT); \
			dsymutil $(SYMROOT)/$$file; \
		done; \
	fi


#
# Unnstall all targets...
#

uninstall:
	echo "Uninstalling IPP tools from $(BUILDROOT)$(bindir)..."
	for file in $(IPPTOOLS); do \
		$(RM) $(BUILDROOT)$(bindir)/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(bindir)
	echo "Uninstalling print commands from $(BUILDROOT)$(libexecdir)/command..."
	for file in $(IPPEVECOMMANDS); do \
		$(RM) $(BUILDROOT)$(bindir)/$$file; \
		$(RM) $(BUILDROOT)$(libexecdir)/command/$$file; \
	done
	-$(RMDIR) $(BUILDROOT)$(libexecdir)/command


#
# Local programs (not built when cross-compiling...)
#

local:		ippeveprinter-static ippfind-static ipptool-static


#
# Test everything...
#

test:		local
	./run-tests.sh


#
# ippeveprinter
#

ippeveprinter:	ippeveprinter.o ../cups/$(LIBCUPS)
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippeveprinter.o -L../cups -lcups $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ippeveprinter-static
#

ippeveprinter-static:	ippeveprinter.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippeveprinter.o $(PAMLIBS) ../cups/libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ippevepcl
#

ippevepcl:	ippevepcl.o ../cups/$(LIBCUPS)
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippevepcl.o -L../cups -lcups $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ippeveps
#

ippeveps:	ippeveps.o ../cups/$(LIBCUPS)
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippeveps.o -L../cups -lcups $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ippfind
#

ippfind:	ippfind.o ../cups/$(LIBCUPS)
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippfind.o $(DNSSDLIBS) -L../cups -lcups $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ippfind-static
#

ippfind-static:	ippfind.o ../cups/libcups.a
	echo Linking $@
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ippfind.o ../cups/libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ipptool
#

ipptool:	ipptool.o ../cups/$(LIBCUPS)
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ipptool.o -L../cups -lcups $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# ipptool-static
#

ipptool-static:	ipptool.o ../cups/libcups.a
	echo Linking $@...
	$(CC) $(LDFLAGS) $(OPTIM) -o $@ ipptool.o ../cups/libcups.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) $@


#
# Generate the header containing the data for printer.png...
#

pngheader:
	echo "Generating printer-png.h from printer.png..."
	echo "static const unsigned char printer_png[] =" >printer-png.h
	echo "{" >>printer-png.h
	od -t x1 printer.png | cut -b12- | awk '{printf("  "); for (i = 1; i <= NF; i ++) printf("0x%s,", $$i); print "";}' >>printer-png.h
	echo "};" >>printer-png.h


#
# Dependencies...
#

include Dependencies

## ippsample 0.0~git20220215.f365352

=== debian/changelog ===
ippsample (0.0~git20220215.f365352-1) unstable; urgency=medium

  * New upstream release

 -- Thorsten Alteholz <debian@alteholz.de>  Fri, 01 Apr 2022 23:50:59 +0000

ippsample (0.0~git20211022.c75af30-2) unstable; urgency=medium

  * debian/control: add Conflicts: with cups-ipp-utils
                    (Closes: #998446)

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 05 Jan 2022 12:59:12 +0100

ippsample (0.0~git20211022.c75af30-1) unstable; urgency=medium

  * New upstream release
  * debian/control: set Rules-Requires-Root: to binary-targets
                    (due to upstream install)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 31 Oct 2021 21:59:12 +0000

ippsample (0.0~git20210916.53e4740-2) unstable; urgency=low

  * upload source package

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 30 Oct 2021 00:42:01 +0200

ippsample (0.0~git20210916.53e4740-1) unstable; urgency=low

  * Initial Release. (Closes: #935435)
    (based on the initial work by Till Kamppeter)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 20 Sep 2021 20:42:01 +0200

=== debian/control ===
Source: ippsample
Priority: optional
Section: net
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>,
		Till Kamppeter <till.kamppeter@gmail.com>
Build-Depends: debhelper-compat (= 13),
		avahi-daemon,
		avahi-utils,
		libavahi-client-dev,
		libgnutls28-dev,
		libjpeg-dev,
		libnss-mdns,
		libpng-dev,
		zlib1g-dev,
		libmupdf-dev
Homepage: http://istopwg.github.io/ippsample/
Standards-Version: 4.6.0
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/printing-team/ippsample
Vcs-Git: https://salsa.debian.org/printing-team/ippsample.git

Package: ippsample
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, ippsample-data
Conflicts: cups-ipp-utils
Multi-Arch: foreign
Description: samples/development tools for the IPP
 The ippsample project provides sample implementations of an IPP
 Client, Proxy, Server, and other tools. It is based on the CUPS
 source code and is maintained by the PWG IPP workgroup.

Package: ippsample-data
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: ippsample (>= ${source:Version})
Conflicts: cups-ipp-utils
Description: samples/development tools for the IPP (data)
 The ippsample project provides sample implementations of an IPP
 Client, Proxy, Server, and other tools. It is based on the CUPS
 source code and is maintained by the PWG IPP workgroup.
 .
 This package contains files for /usr/share

=== debian/rules ===
#!/usr/bin/make -f

# Enabling PIE globally doesn't work, but ./configure already enables PIE
# where necessary.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# as needed is the default now and is just needed for backports
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# The build system uses only DSOFLAGS but not LDFLAGS to build some libraries.
# Add LDFLAGS to enable (hardening) build flags.
export DSOFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# autoreconf intentionally deactivated, upstream knows more about the real reason
%:
	dh $@ --without autoreconf

override_dh_auto_clean:
	[ ! -f Makedefs ] || dh_auto_clean
	[ ! -f Makedefs ] || make distclean

# for whatever reason mupdf is not really detected here
override_dh_auto_configure:
	dh_auto_configure -- --with-pdfrip=auto

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
  https://github.com/istopwg/ippsample \
  HEAD debian uupdate

# Use the following when upstream starts to tag releases:
#
#version=4
#opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ipsample-$1.tar.gz%,\
#      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
#  https://github.com/istopwg/ippsample/tags .*/v?(\d\S*)\.tar\.gz debian uupdate

## ippsample 0.0~git20220607.72f89b3

=== debian/changelog ===
ippsample (0.0~git20220607.72f89b3-1) unstable; urgency=medium

  * New upstream release
  * debian/rules: tests for libcups do not really work here, so
                  they are deactivated for now (Closes: #1009437)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 19 Jun 2022 11:50:59 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
 		libnss-mdns,
 		libpng-dev,
 		zlib1g-dev,
-		libmupdf-dev
+		libmupdf-dev,
+		libcups2-dev
 Homepage: http://istopwg.github.io/ippsample/
 Standards-Version: 4.6.0
 Rules-Requires-Root: binary-targets
@@ -23,7 +24,7 @@
 Package: ippsample
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ippsample-data
+Depends: ${shlibs:Depends}, ${misc:Depends}, ippsample-data, libcups2
 Conflicts: cups-ipp-utils
 Multi-Arch: foreign
 Description: samples/development tools for the IPP

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,8 @@
 export DSOFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
 
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
+DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
 
 # autoreconf intentionally deactivated, upstream knows more about the real reason
 %:
@@ -24,3 +26,11 @@
 # for whatever reason mupdf is not really detected here
 override_dh_auto_configure:
 	dh_auto_configure -- --with-pdfrip=auto
+
+override_dh_auto_test:
+	echo "libcups tests do not really work here, so deactivating them for now"
+
+override_dh_shlibdeps:
+	find
+	pwd
+	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l$(shell pwd)/debian/tmp/usr/lib/$(DEB_BUILD_GNU_TYPE)/

=== debian/watch ===
--- 
+++ 
@@ -1,7 +1,7 @@
 version=4
 opts="mode=git, pgpmode=none" \
   https://github.com/istopwg/ippsample \
-  HEAD debian uupdate
+  HEAD debian ./debian/get-orig-source.sh
 
 # Use the following when upstream starts to tag releases:
 #
